/*

    OOOO   O    O  OOOOO   OOOOO    OOOO   OOOOO    OOOOO   OOOO
   O       O    O  O    O  O    O  O    O  O    O     O    O
    OOOO   O    O  O    O  O    O  O    O  O    O     O     OOOO
        O  O    O  OOOOO   OOOOO   O    O  OOOOO      O         O
   O    O  O    O  O       O       O    O  O   O      O    O    O
    OOOO    OOOO   O       O        OOOO   O    O     O     OOOO

  nouveau Thu 22 Dec 2022 11:50:30 AM CET
*/

/*    ======================================================    */
/*
 *	new: Tue Jan  9 23:06:48 UTC 2024
 */
#declare Support_Bois_0 = object
{
#local SP = 0.06;
#local TR = D_base * 0.54;
#local TB = TR * 1.414;
#local SB = 0.03;
#local HB = 0.14;

union	{
	box { <-SP, 0, -SP>, <SP, H_stand, SP>
		texture {  T_Wood35 rotate <90, -6, 7> }
					translate <-TR 0, -TR> }
	box { <-SP, 0, -SP>, <SP, H_stand, SP> 
		texture {  T_Wood35 rotate <90, -3, -3> }
					translate < TR, 0, -TR> }
	box { <-SP, 0, -SP>, <SP, H_stand, SP> 
		texture {  T_Wood35 rotate <92,  6, 9> }
					translate <-TR, 0,  TR> }
	box { <-SP, 0, -SP>, <SP, H_stand, SP> 
		texture {  T_Wood35 rotate <84, -9, 0> }
					translate < TR, 0,  TR> }

	box { <-TB, -HB, -SB>, <TB, 0, SB>
		texture {  T_Wood35 rotate <2,  6, 9> }
		rotate  y*45 translate y*H_base }
	box { <-TB, -HB, -SB>, <TB, 0, SB>
		texture {  T_Wood35 rotate <9,  6, 9> }
		rotate -y*45 translate y*H_base }

	}
}

/*    ======================================================    */
/*
 *	new: Tue Feb  6 08:39:09 UTC 2024
 */
#declare Support_Pierre_forme = object
{
#local h2 = H_base / 1.3333;
merge	{
	cylinder { 0, y*h2, D_base }
	cone { y*h2, D_base, y*H_base, D_base*0.85 }
	}
}

#declare Support_Pierre = object
{
object { Support_Pierre_forme texture { T_Stone25 scale 7.1 } }

}

/*    ======================================================    */
/*
 *	new Fri 14 Apr 2023 09:12:22 PM UTC
 */
#declare Base_Champi = object
{
#local rbc = 1.16;
#local EC = rbc*0.75;
difference {
	cylinder { <0, 0, 0>, <0, H_base, 0>, rbc }
	cone { <0, H_base-0.1, 0>, EC-0.01, <0, EC+0.1, 0>, rbc+0.01 }
	torus { rbc+0.045, 0.06 translate y*(1.0181*H_base) }
	torus { rbc+0.045, 0.06 translate y*(0.6666*H_base) }
	torus { rbc+0.045, 0.06 translate y*(0.3333*H_base) }
	#for (foo, 0, 360, 6)
	  #local dX = rbc * sin(radians(foo));
	  #local dZ = rbc * cos(radians(foo));
	  cylinder { 0, y, 0.025 translate <dX, 0, dZ> }
	#end
	}
texture { MON_BLEU_SOMBRE }

#undef EC
#undef rbc
}

/*    ======================================================    */

#declare D_stand = D_base * 0.74;

#declare Table_Stand_A = object
{
difference {
	#local D2 = D_stand - 0.04;
	#local H2 = H_stand - 0.03;
	box { <-D_stand, 0, -D_stand>, <D_stand, H_stand-0.01, D_stand> }
	box { <-D2, 0, -D2>, <D2, H2, D2> }
	#local D3 = D2 - 0.12;
	#local H3 = H2 - 0.15;
	box { <-5, -0.20, -D3>, <5, H3, D3> } 
	box { <-D3, -0.20, -5>, <D3, H3, 5> } 
	}
texture {
	pigment { color Orchid }
	normal { granite 0.10 scale 0.21 }
	finish { phong PHONG  specular SPECULAR }
	}
}
#declare Table_Stand_B = object
{
box { 		<-D_stand, H_stand-0.010, -D_stand>,
		< D_stand, H_stand+0.003,  D_stand> }
texture {
	pigment { color Pink }
	finish { phong PHONG  specular SPECULAR }
	}
}

#declare Table_Stand = object
{
union {
	object { Table_Stand_A }
	object { Table_Stand_B }
	}
}
/*    ======================================================    */

#declare Base_Trucs_c = object
{
#local d2 = D_base - 0.09;
box { <-d2, H_base-0.051, -d2>, <d2, H_base, d2> }
texture { Nouvelle_Texture scale 0.075 }
}

#declare Base_Trucs_b = object
{
/*
 *	pour decouper les faces de la base
 */
#local DT  = H_base * 0.296;
#local DT2 = DT * 0.5;
#local Dt  = 0.0555;
union	{
	torus { DT,  Dt                 }
	torus { DT2, Dt                 }
	}
scale <1, 1.222, 3.70>
rotate 90*z
}

#declare Base_Trucs_a = object
{
#local ee = D_base + 0.035;
#local hh = H_base * 0.48;
difference	{
	box { <-D_base, 0, -D_base>, <D_base, H_base-0.05, D_base> }
	object { Base_Trucs_b translate <-ee, hh,   0> }
	object { Base_Trucs_b translate < ee, hh,   0> }
	object { Base_Trucs_b rotate y*90 translate <  0, hh, -ee> }
	object { Base_Trucs_b rotate y*90 translate <  0, hh,  ee> }
	}
texture { Nouvelle_Texture scale 0.090 }
}

#declare Base_Trucs = object
{
union	{ 
	object { Base_Trucs_a }
	object { Base_Trucs_c }
	}
}
/*    ======================================================    */
/*
 *	new: Sat Jan  6 00:16:34 UTC 2024
 */



/*    ======================================================    */

#declare Base_Machins_a = object
{
#local d2 = D_base - 0.09;
union {
	box { <-D_base, 0, -D_base>, <D_base, H_base-0.05, D_base> }
	box { <-d2, 0, -d2>, <d2, H_base, d2> }
	}
}

#declare Base_Machins_b = object
{
#local DT  = H_base * 0.296;
#local DT2 = DT * 0.5;
#local Dt  = 0.0437;
#local ec  = 0.57;
union {
	torus { DT,  Dt translate -ec*z }
	torus { DT2, Dt translate -ec*z }
	torus { DT,  Dt                 }
	torus { DT2, Dt                 }
	torus { DT,  Dt translate  ec*z }
	torus { DT2, Dt translate  ec*z }
	}
rotate 90*z
}

#declare Base_Machins = object
{
#local ee = D_base + 0.035;
#local hh = H_base * 0.48;
difference	{
	object { Base_Machins_a }
	object { Base_Machins_b translate <-ee, hh,   0> }
	object { Base_Machins_b translate < ee, hh,   0> }
	object { Base_Machins_b rotate y*90 translate <  0, hh, -ee> }
	object { Base_Machins_b rotate y*90 translate <  0, hh,  ee> }
	}
texture {
	pigment { color rgb <0.6, 0.3, 0.3>  }
	normal { granite 0.18 scale 0.53 }
	finish { phong PHONG  specular SPECULAR }
	}
}

/*    ======================================================    */
/*
 *	ancien truc
 */
#declare Seconde_base_a = object
{
#local DE = D_base + 0.10;
#local HE = 0.33;
#local RE = 0.012;
difference {
	box { <-D_base, 0, -D_base>, <D_base, H_base-0.15, D_base> }
	merge {
		cylinder { <-DE, 0, -D_base>, < DE, 0, -D_base>, RE }
		cylinder { <-DE, 0,  D_base>, < DE, 0,  D_base>, RE }
		cylinder { <-D_base, 0, -DE>, <-D_base, 0,  DE>, RE }
		cylinder { < D_base, 0, -DE>, < D_base, 0,  DE>, RE }
		scale <1, 2.8, 1> translate y*HE
		}
	}
}

#declare Seconde_Base_b = object
{
#local d2 = D_base - 0.15;
merge {
	object { Seconde_base_a }
	box { <-d2, 0, -d2>, <d2, H_base, d2> }
	}
texture {
	pigment { color <0.397, 0.499, 0.425> }
	normal { bumps 0.58 scale 1.75 }		// XXX
	finish { phong PHONG specular SPECULAR }
	}
#undef d2
}

#declare Seconde_Base = object
{
merge	{
	object { Seconde_Base_b translate -y*0.012 }
	object { Seconde_Base_b scale <0.83, 1, 0.83> rotate y*46 }
	}
}

/*    ======================================================    */

#local RBTR = 1.12;		// rayon du plateau

#declare Base_Ronde_Pieds = object
{
union	{
	cylinder { <0, H_base-0.10, 0>, <0, H_base, 0>, RBTR }
	torus { RBTR, 0.05 translate (H_base-0.05)*y }
	#for (foo, 0, 360, 27.6923)
	  #local dxa = RBTR * 0.92 * sin(radians(foo));
	  #local dza = RBTR * 0.92 * cos(radians(foo));
	  #local dxb = RBTR * 0.80 * sin(radians(foo));
	  #local dzb = RBTR * 0.80 * cos(radians(foo));
	  cone { <dxa, -0.02, dza>, 0.075, <dxb, H_base-0.01, dzb>, 0.045 }
        #end
	}
texture {
	pigment { color Khaki }
	finish { phong PHONG specular SPECULAR }
	}
}

/*    ------------------------------------------------------    */

#declare Base_Ronde_bloc = object
{
#local R_base = 0.99;
merge {
	/* XXX */
	difference {
		cylinder { 0, <0, 0.50, 0>, R_base }
	#for (foo, 0, 360, 8.571428571)
		#local bar = radians(foo);
		#local R2 = R_base + 0.066;
		#local dx = R2 * sin(bar);
		#local dz = R2 * cos(bar);
		#local haut = 0.30;
		#local bas  = 0.10;
		#local minid = 0.075;
		cylinder { <0, bas, 0>, <0, haut, 0>, minid
				translate <dx, 0, dz> }
		sphere { <0, bas, 0>, minid
				translate <dx, 0, dz> }
		sphere { <0, haut, 0>, minid
				translate <dx, 0, dz> }

		#local bar = radians(foo) - (NormClock*2.717);
		#local dx = R2 * sin(bar);
		#local dz = R2 * cos(bar);
		sphere { <0, haut+0.11, 0>, minid * 0.967
				translate <dx, 0, dz> }

	#end
		}
/*
 *	question con : quelle est la vrai hauteur de ce truc ?
 */
	cone { <0, 0.50, 0>, R_base, <0, 0.65, 0>, R_base*0.73 }
	}
texture {
	pigment { color <0.14, 0.16, 0.22>	}
	normal  { bozo 1.8 scale 1.5		}
	finish { phong PHONG specular SPECULAR 	}
	}
}

#declare Base_Ronde = object
{
object { Base_Ronde_bloc }
}

/*    ======================================================    */

